<!DOCTYPE html>
<html lang="en">

<head>
	<meta charset="UTF-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<link rel="stylesheet" href="../CSS and JS\style.css">
	<link rel="stylesheet" href="../CSS and JS\prism.css">
	<link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

	<title>std::cout</title>
</head>

<body>
	<h1>std::cout</h1>
	<a href="https://en.cppreference.com/w/cpp/io/cout">For mer info klikk her.</a>
	<h2>Intro</h2>
	<p>
		std::cout er c++ sin metode for å printe ut til terminalen.
		For å bruke std::cout må man inkludere &ltiostream&gt.
		I eksempelet under ser du hvordan man bruker std::cout til å printe ut en string og sammelignet med den ekvivalente
		koden i python.
	</p>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
#include &ltiostream&gt
int main()
{
	std::cout &lt&lt "Hello world\n";
	// python: print("Hello world")
}
</code>
	</pre>
	<p>
		Merk her at i c++ må man inkludere \n (newline) for å sørge for at neste linje som blir skrevet ut, blir skrevet på
		ny linje.
		Dette er i motsetning til python hvor default/standard er at print inkluderer newline, men kan evenutelt fjernes.
		Dette betyr at det er enkelt i c++ å skrive videre på samme linje hvis man ønsker.
	</p>

	<h2>std::endl</h2>
	<p>
		Ettersom det er relativt vanlig å avslutte med newline er det std::endl implementert for å gi en litt mer intuitv
		måte å avslutte linjen på.
	</p>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
std::cout &lt&lt "Hello world" &lt&lt std::endl;
</code>
	</pre>

	<h2>Printe mer enn én ting</h2>
	<p>
		Som vi så over er det mulig å printe ut flere ting om gangen. Her "Hello world" og std:cin.
		std:cout kan ha vilkårlig antall ledd på denne måten.
	</p>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
std::cout &lt&lt "Hello, " &lt&lt "I " &lt&lt "am " &lt&lt 10 &lt&lt " years " &lt&lt "old." &lt&lt std::endl;
</code>
	</pre>

	<h2>Støtte mange typer</h2>
	<p>En av fordelene med std::cout er at den støtter mange forskjellige typer.</p>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
std::cout << "int: " << 565 << std::endl;
std::cout << "double: " << 3.14 << std::endl;
std::cout << "char: " << 'c' << std::endl;
std::cout << "bool: " << true << std::endl;
</code>
	</pre>

	<h2>Overlasting av &lt&lt-operatoren</h2>
	<p>
		std::cout støtter ikke alle typer uten videre.
		For eksempel vil ikke std::cout uten videre vite hvordan den skal printe ut egendefinerte klasser.
		For å printe ut egendefinerte klasser må vi først overskrive &lt&lt-operatoren.
	</p>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
// Headerfil (person.hpp)

#pragma once
#include &ltstring>
#include &ltostream>

class Person
{
private:
	std::string fornavn;
	std::string etternavn;
public:
	Person(std::string fornavn, std::string etternavn) : fornavn(fornavn), etternavn(etternavn) {};
	std::string getFornavn() {return fornavn;}
	std::string getEtternavn() {return etternavn;}
};

std::ostream& operator<<(std::ostream& os, Person &person);
</code>
	</pre>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
// Implemetasjonsfil (person.cpp)

#include "person.hpp"

std::ostream& operator<<(std::ostream& os, Person &person) {
	return os << person.getFornavn() << " " << person.getEtternavn();
}
</code>
	</pre>
	<pre>
		<button class="copy" title="Copy"><i class="material-icons" style="font-size: 1rem; position: relative; top: .15rem;">content_copy</i></button>
<code class="language-cpp">
// Hovedfil (main.cpp)

#include &ltiostream>
#include "foodPriceMap.hpp"
#include "person.hpp"
int main()
{
	Person Ola{"Ola", "Normann"};
	std::cout << "Person: " << Ola << std::endl;
}
</code>
	</pre>

	<h2>std::cin, input</h2>
	<p>
		Se artikkelen om cin for å lese om hvordan man tar imot input fra brukeren i terminalen.
	</p>

	<script src="../CSS and JS\prism.js"></script>
	<script src="../CSS and JS/copy.js"></script>
</body>

</html>